
XIncludeFile "PortAudio.pb"

#SampleRate = 48000

#PI2 = 6.28318530717958

Global Pee.l

Global InitializeTheWaveform.l=0

Global Kata.s

Global CBVal.f

Global NumSamplePoints.l

Global OscMixLevel.d = 50

Global Kee.l = 0 

Global BitOpType.l=1


Global Slider1BarTop.l = 40
Global Slider1BarBottom.l = 90
Global Slider1BarTopMoving.l=0
Global Slider1BarBottomMoving.l=0


Enumeration
  #WIN_MAIN
  #PlayPauseButton
  #MIDIDevice
  #Trackbar_Attack
  #Trackbar_Decay
  #Trackbar_Sustain
  #Trackbar_Release
  #Text_Attack
  #Text_Sustain
  #Text_Decay
  #Text_Release
  
  #Option_BTS1
  #Option_BTS2
  #Option_BTS3
  #Option_BTS4
  #Option_BTS5
  #Option_BTS6
  #Option_BTS7
  #Option_BTS8
  #Option_BTS9
  #Option_BTS10
  #Option_BTS11
  #Option_BTS12
  #Option_BTS13

  #GADGET_FrameBitOperation
  #GADGET_FrameBitOperation2
  #Trackbar_OscMix
EndEnumeration

Enumeration
  #Off
  #On
EndEnumeration

#PI2 = 6.28318530717958

Global State.i

Global SampleCounter.l

Global ForcedDecayCounter.l=0
Global Groucho.d=0
Global InitializeSampleCounter.l=0

;midi stuff
Global Chromatic$
Chromatic$="C C#D EbE F F#G AbA BbB C "
Global NoteVal.l
Global Freq.d
Global NoteCheck.i
Global foo.l
Global p.d
Global i.d

Global OldFreq.d=100

;ADSR stuff
Global Attack.d
Global Decay.d
Global Sustain.d
Global Release.d

Global AttackSamples.d
Global DecaySamples.d
Global SustainLevel.d
Global ReleaseSamples.d

Global ADSRLevel.d
Global UptoV.d ;the ADSR level we have reached when Release strikes
Global UptoP.l ;samplecount we have reached when the Release strikes


NoteCheck = 0

Declare.f DoTheBitTwiddleCast(SampleNum.l, xval.f)
Declare.f DoTheBitTwiddleUnCast(SampleNum.l, xval.f)
Declare.f CalculateTheWaveform(SamplePoint.l)
Declare ShowAboutWindow()

Global Upper.f = 55
Global Lower.f = 50


Macro ROR_byte(value, n)
   ; rotate right the 7 bits of an 8 bit signed value, sign is preserved
   ; n must be in the range of 0 to 7
   ((value & $7F) >> n) | (value & (1 << n - 1)) << (7 - n) | (value & $80)
EndMacro

Macro ROL_byte(value, n)
   ; rotate left the 7 bits of an 8 bit signed value, sign bit is preserved
   ; n must be in the range of 0 to 7
   ($7F >> n & value) << n | (value & $7F) >> (7 - n) | (value & $80)
 EndMacro
 
 Procedure RLByte(b.a, bits)
  If bits<8 And bits>0
    !xor eax, eax
    !mov ecx, [p.v_bits]
    !mov al, [p.v_b]
    !rol al, cl
    ProcedureReturn
  EndIf
EndProcedure

Procedure RRByte(b.a, bits)
  If bits<8 And bits>0
    !xor eax, eax
    !mov ecx, [p.v_bits]
    !mov al, [p.v_b]
    !ror al, cl
    ProcedureReturn
  EndIf
EndProcedure


Procedure.i MIDI_GetInputDevices()
 
  Protected mic.MIDIINCAPS, Num.i, i.i
 
  Num = midiInGetNumDevs_()
  For i = 0 To Num - 1
    If midiInGetDevCaps_(i, @mic, SizeOf(MIDIINCAPS)) = 0
      AddGadgetItem(#MIDIDevice, -1, PeekS(@mic\szPname))
    EndIf
  Next i
 
  ProcedureReturn Num
 
EndProcedure


Procedure.s MIDI_Note(Note);returns note's name
   ProcedureReturn Trim(Mid(Chromatic$, (Note % 12) * 2 + 1, 2)) + Str(Note / 12)
EndProcedure


Procedure MidiInCallback(hMidiIn.i, wMsg.i, dwInstance.l, dwParam1.l, dwParam2.l)
 
  Protected Note.i, Velocity.i, Status.i
  Static KeyCounter.i
  
  Select wMsg    ; process MIDI in events
    Case #MIM_CLOSE
      KeyCounter = 0
      State = #Off
      kata = "Off"
    Case #MM_MIM_DATA
      Status = dwParam1 & $FF
      If Status = $90
        Note = (dwParam1 >> 8) & $FF
        Velocity = (dwParam1 >> 16) & $FF
        If Velocity
          Freq = Pow(2, (Note - 69) / 12) * 440
          If KeyCounter = 0
            State = #On
            kata = "On"
          EndIf
          ;If IsStatusBar(0) : StatusBarText(0, 1, MIDI_Note(Note) + " " + Str(Velocity), #PB_StatusBar_Center) : EndIf
          KeyCounter + 1
        Else
          If KeyCounter : KeyCounter - 1 : EndIf
          If KeyCounter = 0
          State = #Off
          kata = "Off"
          InitializeTheWaveform = 0
          InitializeSampleCounter = 0
          OldFreq = Freq
          EndIf
        EndIf
      EndIf 
      
      If Status = $80
        If KeyCounter : KeyCounter - 1 : EndIf
        If KeyCounter = 0
          State = #Off 
          kata = "Off"
          InitializeTheWaveform = 0
          InitializeSampleCounter = 0
          OldFreq = Freq
        EndIf
      EndIf
      
      If IsStatusBar(0) : StatusBarText(0, 1, kata, #PB_StatusBar_Center) : EndIf

  EndSelect
EndProcedure
;end midi stuff


Procedure Error(err)
  MessageRequester("PortAudio", PeekS(Pa_GetErrorText(err)))
  End
EndProcedure


 Procedure.f CalculateTheWaveform(SamplePoint.l)
   
  Protected RawTwiddledVal.f 
    
If Freq>0 
   
  If ForcedDecayCounter<=1000
  NumSamplePoints = #SampleRate/(OldFreq)
  Else  
  NumSamplePoints = #SampleRate/(Freq)
  EndIf

  Pee = Pee+1
  
    If Pee = NumSamplePoints
      Pee = 0
    EndIf
    
    If BitOpType = 11 Or BitOpType = 12 Or BitOpType = 13
      RawTwiddledVal = DoTheBitTwiddleUnCast(SamplePoint, Pee/NumSamplePoints)
    Else
      RawTwiddledVal = DoTheBitTwiddleCast(SamplePoint, Pee/NumSamplePoints)
    EndIf      
EndIf       
ProcedureReturn RawTwiddledVal
     
EndProcedure  


Procedure.f DoTheBitTwiddleCast(SampleNum.l, xval.f)
;this is the bit twiddling calculator used in the sound production. in this procedure, the twiddledvalue is cast as a byte 
  
osc1val.f = ((Slider1BarBottom +ADSRLevel*(Slider1BarTop-Slider1BarBottom))/250)*Sin(#PI2*xval)

Osc1BinaryVal.b = (osc1val)*127

mask.b = OscMixLevel

;*******rotate bits left, leaving the most left hand bit untouched**********
If BitOpType = 5
  TwiddledVal.b = ROL_byte(Osc1BinaryVal,2)
EndIf  

;*******shift bits left***********************
If BitOpType = 4
  TwiddledVal.b= Osc1BinaryVal<<2
EndIf  

;********AND the bits with a static value***********

;static value is set by the mix slider - that is the mask value
If BitOpType = 2
  TwiddledVal.b = Osc1BinaryVal & mask ;and
EndIf  
If BitOpType = 1
  TwiddledVal.b = Osc1BinaryVal | mask ;or
EndIf
If BitOpType = 3
  TwiddledVal.b = Osc1BinaryVal ! mask ;xor
EndIf  

;********check whether a bit pattern appears and if it does, flip one or more bits**********

;if the value of the bit pattern is positive: then If bits 4 And 5 from left are 0, make them both 1, otherwise output 0 bit pattern. If the value of bit pattern is negative: always output a 0 bit pattern
If BitOpType = 8
Checkdigit1.b = 8
Checkdigit2.b = 16
  If ((Osc1BinaryVal & Checkdigit1) = 0) And ((Osc1BinaryVal & Checkdigit2) = 0) ;this means the 4th and 5th digits from the right are 0
  mask.b = 1
  ;in following, numbering starts from 0 at rightmost bit. we are making both the 4th And 5th digits 1
  TwiddledVal.b = Osc1BinaryVal ! (mask <<3)
  TwiddledVal = TwiddledVal ! (mask <<4)
  EndIf
EndIf  

;************unconditionally flip one or more bits**************

;let's just flip 5th bit from the left, no matter what its value is:
If BitOpType = 10
mask.b = 1
TwiddledVal.b = Osc1BinaryVal ! (mask <<3)
EndIf

;***************consider first four digits from left only************************
If BitOpType = 6
hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
;try following as alternative:  
;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
subone.s = "%" + Mid(hofa, 1, 4) + "0000"
firsthalf.b = Val(subone)
TwiddledVal.b = firsthalf 
EndIf
;***************if digits 3 to 5 from left are all 0, then make digits 2 to 6 from left all 1s************************
If BitOpType = 9
  hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
  ;try following as alternative:  
  ;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
  If Mid(hofa, 3, 3) = "000" 
    subone.s = "%" + Mid(hofa, 1, 1) + "11111"+ Mid(hofa, 7, 2)
  Else
    subone.s = "%" + hofa
  EndIf  
  TwiddledVal.b = Val(subone)
EndIf

;***************if from left third digit is 0 and fourth is one, make fourth 0. Else. If third digit is one and fourth is one, make third 0************************
If BitOpType = 7
hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
;try following as alternative:  
;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
If Mid(hofa, 4, 1) = "1" And Mid(hofa, 3, 1) = "0"
  subone.s = "%" + Mid(hofa, 1, 3) + "0"+ Mid(hofa, 5, 4)
ElseIf Mid(hofa, 3, 1) = "1" And Mid(hofa, 4, 1) = "1"
  subone.s = "%" + Mid(hofa, 1, 2) + "0"+ Mid(hofa, 4, 5)
;try following as alternative:
;Else
  ;subone.s = "%" + hofa  
EndIf  
TwiddledVal.b = Val(subone)
EndIf

cbval = TwiddledVal/127

ProcedureReturn CBVal

EndProcedure

Procedure.f DoTheBitTwiddleUnCast(SampleNum.l, xval.f)
;this is the bit twiddling calculator used in the sound production. in this procedure the twiddled value is not cast as a byte (no .b suffix)

osc1val.f = ((Slider1BarBottom +ADSRLevel*(Slider1BarTop-Slider1BarBottom))/250)*Sin(#PI2*xval)

Osc1BinaryVal.b = (osc1val)*127

mask.b = OscMixLevel


;*************take a substring and reverse it******************
;yessiree, we are going to take substring 2,3,4 from the left, and reverse it. we are going to use some string manipulation trickery for this one
If BitOpType = 11
  hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
  ;try following as alternative:  
  ;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
thesub.s = ReverseString(Mid(hofa, 2, 3))
reassembled.s = "%" + Mid(hofa, 1,1) + thesub + Mid(hofa, 5, 4)
TwiddledVal = Val(reassembled)
EndIf

;*************take a substring, reverse it, and paste it in a different location of the bit pattern******************
;take substring 2,3,4 from the left, and reverse it
If BitOpType = 12 
  hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
  ;try following as alternative:  
  ;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
thesub.s = ReverseString(Mid(hofa, 2, 3))
;now take the reversed pattern, and paste it in position 3
reassembled.s = "%" + Mid(hofa, 1,3) + thesub + Mid(hofa, 7, 2)
TwiddledVal = Val(reassembled)
EndIf

;*************take two substrings and swap their positions****************
If BitOpType = 13
  hofa.s = RSet(Bin(Osc1BinaryVal), 8, "0")
  ;try following as alternative:  
  ;hofa.s = RSet(Bin(Osc1BinaryVal, #PB_Byte), 8, "0")
subone.s = (Mid(hofa, 2, 2))
subtwo.s = (Mid(hofa, 5, 2))
;now swap them around in the pattern
reassembled.s = "%" + Mid(hofa, 1,1) + subtwo + Mid(hofa, 4, 1) + subone + Mid(hofa, 7, 2)
TwiddledVal = Val(reassembled)
EndIf

cbval = TwiddledVal/127

ProcedureReturn CBVal  

EndProcedure


Global Stream


Procedure LevelADSR(SampleTracker.l)
  
If SampleTracker>2147483640
SampleCounter = 0
UptoV = 0
EndIf  
 
If State = #Off
    If (ReleaseSamples+UptoP-SampleTracker)>=0
      ADSRLevel = (UptoV*(ReleaseSamples+UptoP-SampleTracker))/ReleaseSamples  
    Else
      ADSRLevel = 0
    EndIf 
    Groucho = ADSRLevel
  If IsStatusBar(0)
  EndIf
EndIf
 
 If State = #On
   If InitializeTheWaveform = 0
     InitializeTheWaveform = 1
     ForcedDecayCounter = -1
            
      Attack = (0.0994856*Pow(1.00517037535,GetGadgetState(#Trackbar_Attack)))/1000
      Decay = GetGadgetState(#Trackbar_Decay) / 1000
      Sustain = GetGadgetState(#Trackbar_Sustain) / 100
      Release = GetGadgetState(#Trackbar_Release) / 1000
      
      AttackSamples = Attack*#SampleRate
      DecaySamples = Decay*#SampleRate
      SustainLevel = Sustain
      ReleaseSamples = Release*#SampleRate
      kee = 0
            
    EndIf
    
    ForcedDecayCounter = ForcedDecayCounter+1
    If ForcedDecayCounter<=1000
      ADSRLevel = (1-Pow((ForcedDecayCounter/1000),1))*Groucho
    Else
      ;got to set the following only the FIRST TIME ForcedDecayCounter increments above 1000 samples:
      If InitializeSampleCounter = 0 
      Pee = -1
      InitializeSampleCounter = 1  
      SampleCounter = 0
      SampleTracker = 0
      EndIf
      ;let us calculate the actual ADSR level now shall we
          If SampleTracker<=AttackSamples
            ADSRLevel = SampleTracker/AttackSamples
          ElseIf SampleTracker>AttackSamples And SampleTracker<=(AttackSamples+DecaySamples)
            ADSRLevel = SustainLevel + (((AttackSamples+DecaySamples-SampleTracker)*(1-SustainLevel))/DecaySamples)
          ElseIf SampleTracker>(AttackSamples+DecaySamples)
            ADSRLevel = SustainLevel
          EndIf
    EndIf      
    UptoV = ADSRLevel
    UptoP = SampleTracker
    
EndIf   

EndProcedure


ProcedureC PaStreamCallback(*in, *output.Float, frameCount, *timeInfo.PaStreamCallbackTimeInfo, statusFlags, *userData)

  While frameCount
   LevelADSR(SampleCounter)
   If SampleCounter<100
     *output\f = ((CalculateTheWaveform(SampleCounter))*ADSRLevel*Pow((SampleCounter/100),5))
   Else
     *output\f = ((CalculateTheWaveform(SampleCounter))*ADSRLevel)
   EndIf  
      
   SampleCounter = SampleCounter+1  
   *output + 4
   frameCount - 1
Wend
 
EndProcedure


Define err.i

err = Pa_Initialize()
If err <> #paNoError : Error(err) : EndIf

Define op.PaStreamParameters
op\channelCount = 1
op\device = Pa_GetDefaultOutputDevice()
op\sampleFormat = #paFloat32
op\suggestedLatency = 75/1000


;err = Pa_OpenStream(@Stream, #Null, @op, #SampleRate, #SampleRate / 100, #paNoFlag, @PaStreamCallback(), 0)
err = Pa_OpenStream(@Stream, #Null, @op, #SampleRate, #paframesperbufferunspecified, #paNoFlag, @PaStreamCallback(), 0)
If err <> #paNoError : Error(err) : EndIf

Define Indev.i
InDev = 0

Define hMi.i
hMi = 0

If OpenWindow(#WIN_MAIN, 0, 0, 535, 410, "Bit Twiddling Synthesizer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
    If CreateMenu(0, WindowID(#WIN_MAIN))    ; menu creation starts....
      MenuTitle("?")
      MenuItem(1, "About")
      MenuItem(2, "Help")
    EndIf
    
  ;coloured slider  
  CanvasGadget(0, 40, 80, 20, 250, #PB_Canvas_Border)
  StartDrawing(CanvasOutput(0))
  Box(0, 0, 20, 250, $EDEDED)
  Box(0, 40, 20, 50, $009900) ;(x, y, width, height, colour). background color of switch 1
  StopDrawing()
   
 
  ComboBoxGadget(#MIDIDevice, 180, 10, 140, 20)
  If MIDI_GetInputDevices()
    SetGadgetState(#MIDIDevice, 0)
    InDev = 0
  Else
    InDev = -1
  EndIf
  
  Frame3DGadget(#GADGET_FrameBitOperation, 80,  40, 290, 70, "Bit Operations with a Static Value")
  
  OptionGadget(#Option_BTS1, 120, 80, 60, 20, "OR")
  OptionGadget(#Option_BTS2, 200, 80, 60, 20, "AND")
  OptionGadget(#Option_BTS3, 280, 80, 60, 20, "XOR")
  
  OptionGadget(#Option_BTS4, 90, 140, 200, 20, "Shift bits by 2 to left")
  OptionGadget(#Option_BTS5, 90, 160, 300, 20, "Rotate bits by 2 to left, leaving leftmost bit untouched")
  OptionGadget(#Option_BTS6, 90, 180, 300, 20, "Unconditionally make bits 4-8 from left = 0")
  OptionGadget(#Option_BTS7, 90, 200, 420, 20, "If from left, bit3 is 0 and bit4 is 1, make bit4 = 0. If bit3 is 1 and bit4 is 1, make bit3 = 0")
  OptionGadget(#Option_BTS8, 90, 220, 300, 20, "If from left bits 4-5 are 0, make them 1")
  OptionGadget(#Option_BTS9, 90, 240, 300, 20, "If from left, bits 3-5 are 0, make bits 2-6 = 1")
  OptionGadget(#Option_BTS10, 90, 260, 350, 20, "Unconditionally flip value of bit 5 from left")
  OptionGadget(#Option_BTS11, 90, 280, 300, 20, "Unconditionally reverse bits 2-4 from left")
  OptionGadget(#Option_BTS12, 90, 300, 350, 20, "From left, reverse bits 2-4 And paste them at bit position 4")
  OptionGadget(#Option_BTS13, 90, 320, 400, 20, "From left, swap the positions in the bit pattern of bits 2-3 And 5-6")
  
  SetGadgetState(#Option_BTS1, 1)
  
  Frame3DGadget(#GADGET_FrameBitOperation2, 80,  120, 440, 230, "Other Bit Operations")
    
  TrackBarGadget(#Trackbar_Attack, 420, 40, 20, 80, 1, 2000, #PB_TrackBar_Vertical)
  TrackBarGadget(#Trackbar_Decay, 440, 40, 20, 80, 1, 5000, #PB_TrackBar_Vertical)
  TrackBarGadget(#Trackbar_Sustain, 460, 40, 20, 80, 0, 100, #PB_TrackBar_Vertical)
  SetGadgetState(#Trackbar_Sustain, 50)
  
  TrackBarGadget(#Trackbar_OscMix, 100, 60, 250, 20, 0, 100)
  SetGadgetState(#Trackbar_OscMix, 50)

  TrackBarGadget(#Trackbar_Release, 480, 40, 20, 80, 1, 5000, #PB_TrackBar_Vertical)
  SetGadgetState(#Trackbar_Attack, 1)
  SetGadgetState(#Trackbar_Decay, 1000)
  SetGadgetState(#Trackbar_Release, 1500)
 
  TextGadget(#Text_Attack, 425, 27, 10, 20, "A")
  TextGadget(#Text_Decay, 445, 27, 10, 20, "D")
  TextGadget(#Text_Sustain, 465, 27, 10, 20, "S")
  TextGadget(#Text_Release, 485, 27, 10, 20, "R")
  
  If CreateStatusBar(0, WindowID(#WIN_MAIN))
    AddStatusBarField(100)
    AddStatusBarField(100)
    AddStatusBarField(30)
  EndIf
 
  AddKeyboardShortcut(#WIN_MAIN, #PB_Shortcut_Escape, 111)


  ;MIDI STUFF for NOTE ON/OFF DISPLAY
  If midiInOpen_(@hMi, InDev, @MidiInCallback(), 0, #CALLBACK_FUNCTION) = #MMSYSERR_NOERROR
    If midiInStart_(hMi) = #MMSYSERR_NOERROR
      If IsStatusBar(0) : StatusBarText(0, 0, "MIDI IN", #PB_StatusBar_Center) : EndIf
    Else
      If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
    EndIf
  Else
    If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
  EndIf
 
  ;END MIDI STUFF
 
 
  State = #Off
  Pa_StartStream(Stream)
 
  Define Quit.i
  Quit = #False
 
  Define Event.i
  Repeat
    Event = WaitWindowEvent()
    
     
    
    If Event = #PB_Event_Gadget And EventGadget() = 0 
      If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton) 
          If StartDrawing(CanvasOutput(0))
            x = GetGadgetAttribute(0, #PB_Canvas_MouseX)
            y = GetGadgetAttribute(0, #PB_Canvas_MouseY)
            
             If Slider1BarBottomMoving<>1
               If y> Slider1BarTop-5 And y<Slider1BarTop+5
                Slider1BarTopMoving = 1
              EndIf
              If Slider1BarTopMoving = 1   
                If y<244 And y>1 
                  Slider1BarTop = y
                If y<Slider1BarBottom
                  Box(0, 0, 20, 250, $EDEDED)
                  Box(0, y, 20, Slider1BarBottom-y, $009900) ;(x, y, width, height, colour).green
                ElseIf y> Slider1BarBottom
                  Box(0, 0, 20, 250, $EDEDED)
                  Box(0, y, 20, Slider1BarBottom-y, $0000FF) ;(x, y, width, height, colour). red
                EndIf 
              EndIf  
            EndIf
             EndIf 
              
             If Slider1BarTopMoving<>1 
               If y> Slider1BarBottom-5 And y<Slider1BarBottom+5
                 Slider1BarBottomMoving = 1 
               EndIf 
             If Slider1BarBottomMoving = 1 
               If y>3 And y<246
                 Slider1BarBottom = y
                If y>Slider1BarTop
                  Box(0, 0, 20, 250, $EDEDED)
                  Box(0, Slider1BarTop, 20, y-Slider1BarTop, $009900) ;(x, y, width, height, colour). green
                ElseIf y<Slider1BarTop
                  Box(0, 0, 20, 250, $EDEDED)
                  Box(0, Slider1BarTop, 20, y-Slider1BarTop, $0000FF) ;(x, y, width, height, colour). red
                EndIf 
              EndIf  
            EndIf 
             EndIf 
            StopDrawing()
          EndIf
        Else
          Slider1BarTopMoving = 0
          Slider1BarBottomMoving = 0
        EndIf
    EndIf
    
    
    

    
    Select Event
      Case #PB_Event_Menu
        
        Select EventMenu()
        Case 1
        MessageRequester("About", "Bit Twiddling Synthesizer v1.01 " + Chr(169) + " Jim Singh" + Chr(13) + "Sound Synthesizer using bit operations")
        Case 2
        ShowAboutWindow()
        EndSelect
       
        If EventMenu() = 111 : Quit = #True : EndIf
       
      Case #PB_Event_Gadget
        Select EventGadget()
           
          Case #MIDIDevice
            midiInStop_(hMi)
            midiInClose_(hMi)
            InDev = GetGadgetState(#MIDIDevice)
            midiInOpen_(@hMi, InDev, @MidiInCallback(), 0, #CALLBACK_FUNCTION)
            If midiInStart_(hMi) = #MMSYSERR_NOERROR
              If IsStatusBar(0) : StatusBarText(0, 0, "MIDI IN", #PB_StatusBar_Center) : EndIf
            Else
              If IsStatusBar(0) : StatusBarText(0, 0, "No MIDI IN", #PB_StatusBar_Center) : EndIf
            EndIf
           
                                                            
          Case #Trackbar_OscMix
            OscMixLevel = GetGadgetState(#Trackbar_OscMix)
            
          Case #Option_BTS1
            If GetGadgetState(#Option_BTS1) = 1
              BitOpType = 1
            EndIf  
            
          Case #Option_BTS2
            If GetGadgetState(#Option_BTS2) = 1
              BitOpType = 2
            EndIf    
            
          Case #Option_BTS3
            If GetGadgetState(#Option_BTS3) = 1
              BitOpType = 3
            EndIf  
            
          Case #Option_BTS4
            If GetGadgetState(#Option_BTS4) = 1
              BitOpType = 4
            EndIf    
            
          Case #Option_BTS5
            If GetGadgetState(#Option_BTS5) = 1
              BitOpType = 5
            EndIf  
            
          Case #Option_BTS6
            If GetGadgetState(#Option_BTS6) = 1
              BitOpType = 6
            EndIf    
            
          Case #Option_BTS7
            If GetGadgetState(#Option_BTS7) = 1
              BitOpType = 7
            EndIf  
            
          Case #Option_BTS8
            If GetGadgetState(#Option_BTS8) = 1
              BitOpType = 8
            EndIf 
            
          Case #Option_BTS9
            If GetGadgetState(#Option_BTS9) = 1
              BitOpType = 9
            EndIf  
            
          Case #Option_BTS10
            If GetGadgetState(#Option_BTS10) = 1
              BitOpType = 10
            EndIf    
            
          Case #Option_BTS11
            If GetGadgetState(#Option_BTS11) = 1
              BitOpType = 11
            EndIf  
            
          Case #Option_BTS12
            If GetGadgetState(#Option_BTS12) = 1
              BitOpType = 12
            EndIf   
            
          Case #Option_BTS13
            If GetGadgetState(#Option_BTS13) = 1
              BitOpType = 13
            EndIf    
            
        EndSelect
       
      Case #PB_Event_CloseWindow
        Quit = #True
    EndSelect
  Until Quit
 
EndIf


Procedure ShowAboutWindow()
  
  Protected AboutWindow, myEditorGadget, CloseButton 
  Protected Text$
  Protected Quit
  
  AboutWindow = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 620, 373, "Bit Twiddling Synthesizer Help", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
 If AboutWindow
    
myEditorGadget = EditorGadget(#PB_Any, 5, 5, 610, 360, #PB_Editor_ReadOnly)
    
Text$ = Chr($d) + "All the bit operations are performed on a sinewave." + Chr($d)
Text$ + Chr($d) + "Choose an operation. Pull the top and bottom of green rectangle into suitable range for the sound to move smoothly as you play." + Chr($d)
Text$ + Chr($d) + "Can only be played with a virtual or real midi keyboard." + Chr($d)
Text$ + Chr($d) + "Use the ADSR sliders to shape the Attack, Decay, Sustain and Release of the note as you play the keyboard." + Chr($d)
Text$ + Chr($d) + "The way the application works is that each sample value of the sinewave is first converted to an integer that can be"
Text$ + Chr($d) + "represented on the bits of one byte. Then operations are performed on the individual bits like shift them, re-arrange"
Text$ + Chr($d) + "them, flip them, and so on. The 8 bit pattern is finally converted back to a sample value, and output as the new waveform." + Chr($d)


SetGadgetText(myEditorGadget, Text$)
    
    Repeat 
      
      Select WaitWindowEvent()
          
        Case #PB_Event_Gadget :      If EventGadget()=CloseButton : Break : EndIf
        Case #PB_Event_CloseWindow : If EventWindow()=AboutWindow : Break : EndIf 
          
      EndSelect
      
    ForEver
    
    CloseWindow(AboutWindow)
    
 EndIf
  
EndProcedure


Pa_AbortStream(Stream)
While Pa_IsStreamActive(Stream) : WaitWindowEvent(1) : Wend
Pa_Terminate()
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 369
; Folding = ---
; EnableXP
; Executable = Quad-Klanger103.exe
; DisableDebugger